﻿using System;
using System.Web.UI;
using ThinkGeo.MapSuite.Core;
using ThinkGeo.MapSuite.Routing;

namespace Post6431
{
    public partial class _Default : System.Web.UI.Page
    {
        protected void Page_Load(object sender, EventArgs e)
        {
            if (!Page.IsPostBack)
            {
                Map1.MapUnit = GeographyUnit.DecimalDegree;
                Map1.MapBackground.BackgroundBrush = new GeoSolidBrush(GeoColor.FromHtml("#B3C6D4"));
                Map1.CurrentExtent = new RectangleShape(-97.763384, 30.299707, -97.712382, 30.259309);

                ShapeFileFeatureLayer worldLayer = new ShapeFileFeatureLayer(@"C:\Program Files\ThinkGeo\Map Suite Routing Evaluation Edition 3.0(BETA)\HowDoISamples\SampleData\Austinstreets.shp");
                worldLayer.ZoomLevelSet.ZoomLevel01.DefaultLineStyle = LineStyles.LocalRoad3;
                worldLayer.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20;
                Map1.StaticOverlay.Layers.Add(worldLayer);

                RoutingLayer routingLayer = new RoutingLayer();
                routingLayer.StartPoint = new PointShape(-97.75522, 30.28912);
                routingLayer.EndPoint = new PointShape(-97.72465841, 30.267462);
                Map1.DynamicOverlay.Layers.Add("RoutingLayer", routingLayer);
            }
        }

        protected void btnRoute_Click(object sender, EventArgs e)
        {
            RoutingSource routingSource = new RtgRoutingSource(@"C:\Program Files\ThinkGeo\Map Suite Routing Evaluation Edition 3.0(BETA)\HowDoISamples\SampleData\Austinstreets.rtg");
            ShapeFileFeatureSource featureSource = new ShapeFileFeatureSource(@"C:\Program Files\ThinkGeo\Map Suite Routing Evaluation Edition 3.0(BETA)\HowDoISamples\SampleData\Austinstreets.shp");
            RoutingEngine routingEngine = new RoutingEngine(routingSource, featureSource);

            RoutingLayer routingLayer = (RoutingLayer)Map1.DynamicOverlay.Layers[0];
            RoutingResult routingResult = routingEngine.GetRoute(routingLayer.StartPoint, routingLayer.EndPoint);
            routingLayer.Routes.Clear();
            routingLayer.Routes.Add(routingResult.Route);

            Map1.DynamicOverlay.Redraw();
        }
    }
}
